<?php
/* $Id: user_settings.inc.php 16 2009-05-17 07:33:52Z mir $ */

class CalendarInfo {
    public $name;
    public $color;
    public $config;
}

class UserSettings {
    private $calendars;
    private $uid;
    private $viewStyle;
    private $startHour;
    private $endHour;
    private $startWeek;
    private $role;
    private $timeout;
    private $timezone;

    public function __construct($uid) {
        $this->calendars = array();
        $this->uid = $uid;
    }

    public function setCalendars($calendars) {
        $this->calendars = $calendars;
    }

    public function addCalendar($id, CalendarInfo $calendar) {
        $this->calendars[$id] = $calendar;
    }

    public function removeCalendar($id) {
        unset($this->calendars[$id]);
    }

    public function setSettings($settings) {
        //file_put_contents('/tmp/davical.log',
        //    var_export($settings, TRUE), FILE_APPEND);
        $first = TRUE;
        foreach ($settings as $row) {
            if ($first) {
                $this->viewStyle = $row['userview'];
                $this->startWeek = ($row['weekstart']) ? TRUE : FALSE;
                $this->startHour = $row['daystart'];
                $this->endHour = $row['dayend'];
                $this->role = (int) $row['userrole'];
                $this->timeout = (int) $row['timeout'];
                $this->timezone = $row['timezone'];
                $first = FALSE;
            }
            if (isset($row['id']) && $row['id'] >= 0) {
                $calendar = new CalendarInfo();
                $calendar->name = $row['name'];
                $calendar->color = $row['color'];
                $calendar->config = $row['config'];
                $this->calendars[$row['id']] = $calendar;
            }
        }
    }

    public function getCalendars() {
        return $this->calendars;
    }

    public function getCalendar($name) {
        foreach ($this->calendars as $calendar) {
            if ($calendar->name == $name)
                return $calendar->config;
        }
        return NULL;
    }

    public function getViewStyle() {
        return $this->viewStyle;
    }

    public function getStartWeek() {
        return $this->startWeek;
    }

    public function getStartHour() {
        return $this->startHour;
    }

    public function getEndHour() {
        return $this->endHour;
    }

    public function getRole() {
        return (int) $this->role;
    }

    public function getTimeout() {
        return $this->timeout;
    }

    public function getUid() {
        return $this->uid;
    }

    public function getTimezone() {
        return $this->timezone;
    }

}

?>
